[download as pdf](/resume.pdf)

<section id="contact">
  <h1>Jonathan Dahan</h1>

  <p>✉️ <a href="mailto:resume@jonathan.is">hi</a>@<a href="http://jonathan.is">jonathan.is</a>  🕸 <a href="http://jedahan.com">jedahan.com</a> ௮ <a href="https://github.com/jedahan">github.com/jedahan</a></p>
</section>

<section id="experience">
  <h2>experience</h2>

  <div class="position">
    <div class="title">
      <h3>Fullstack Engineer at <a href="https://reaktor.com">Reaktor</a></h3>
      <div>September 2019 - Present</div>
    </div>
    <ul>
      <li>Developed embedded QML application + typescript backend stack for In-Flight Entertainment systems on Delta's largest fleet types.
      <li>Developed cross-platform React Native app and Typescript GraphQL backend api for Sony Music Artists to track their performance on streaming music platforms.
      <li>Integrated third-party streaming audio service into React Native app for Equinox running classes
      <li>Researched and wrote technical proposal for Equinox’s remote training program
      <li>Developed backend data pipeline for realtime East River water quality dashboard at https://water.pluspool.org
    </ul>
  </div>

  <div class="position">
    <div class="title">
      <h3>Founder of <a href="https://baculus.co">Baculus</a></h3>
      <div>August 2018 - August 2019</div>
    </div>
    <ul>
      <li>Developed hardware and software for disaster recovery communications infrastructure.
      <li>Built offline-first, decentralized web applications on top of scuttlebutt (js/nodejs) over IPV6 link-local multicast.
      <li>Wrote custom wireshark dissector in lua for investigating mdns advertisements.
      <li>Managed designers and programmers for a short sprint, winning a Mozilla/NSF phase I grant.
    </ul>
  </div>

  <div class="position">
    <div class="title">
      <h3>Technical Consultant for <a href="https://smalldata.industries">Small Data Industries</a></h3>
      <div>October 2018 - August 2019</div>
    </div>
    <ul>
      <li>Researched and developed preservation strategies for unique hardware such as the IBM Leapfrog and NeXT Computer.
      <li>Architected IPFS-based private cloud storage solution for The Current Museum.
      <li>Wrote GIF case study for the MoMI to highlight the historical decision-making involved in the creation of the GIF file format.
      <li>Developed documentation and code (C/lua) for recreation of Cory Arcangel NES hardware hacks.
    </ul>
  </div>

  <div class="position">
    <div class="title">
      <h3>Fullstack Freelance Engineer for <a href="https://micahwalter.studio">Micah Walter Studio</a></h3>
      <div>September 2017 - June 2018</div>
    </div>
    <ul>
      <li> Built out node.js-based graphql api for mid-sized museums, adapting REST ingestion api and website.
    </ul>
  </div>

  <div class="position">
    <div class="title">
      <h3>Software Engineer for <a href="https://etsy.com">Etsy</a></h3>
      <div>December 2015 - August 2017</div>
    </div>
    <ul>
      <li>Worked on international tax compliance new market expansion, improving the payment processor state machine &amp; api.
      <li>Decreased VAT Invoice pdf generation by 40x.
      <li>Implemented new payments state machine processes during emergency third party outage, allowing us to process over $30 million independently of the outage.
    </ul>
  </div>

  <div class="position">
    <div class="title">
      <h3>Freelance Developer for <a href="http://www.bgc.bard.edu/gallery/gallery-at-bgc/the-interface-experience.html">Bard Graduate Center</a></h3>
      <div>September 2014 - July 2015</div>
    </div>
    <ul>
      <li>Created interactives for five different platforms, illustrating the differences in HCI over 30 years.
      <li>Wrote BASIC for the Commodore 64, HyperTalk for the Mac Plus, native C for the Palm Pilot Professional, javascript/canvas for iOS, and C++/openFrameworks for the kinect.
      <li>Installed and ran in public gallery for 3 months.
    </ul>
  </div>

  <div class="position">
    <div class="title">
      <h3>Freelance Developer for <a href="http://www.rockwellgroup.com/">Lab@Rockwell</a>, <a href="http://www.fakelove.tv/work/exhibit-growth">Fake Love</a></h3>
      <div>October 2013 - October 2014</div>
    </div>
    <ul>
      <li>Built html canvas-based frontend for malls to create digital signage for lab@rockwell.
      <li>Created backend api and email generation and queueing system to reach out to any person who interacted with an iPad openframeworks application.
    </ul>
  </div>

  <div class="position">
    <div class="title">
      <h3>Media Technology Developer at <a href="http://www.metmuseum.org/about-the-museum/museum-departments/office-of-the-director/digital-media-department/medialab">Metropolitan Museum of Art</a></h3>
      <div>February 2012 - August 2014</div>
    </div>
    <ul>
      <li>Developed web-based virtual touchbooks and twitter in-gallery interactives.
      <li>Built collections api in node.js for external use (see Iconoclashes).
      <li>Managed 3D hackathon with two dozen artists.
      <li>Setup projector visualisations for LIARS concert in the temple of dendur built on openFrameworks/C++.
      <li>Worked with bluetooth beacons for wayfinding in galleries.
      <li>Developed open source image recognition software in javascript.
    </ul>
  </div>

  <div class="title">
    <div></div>
    <div>Previous experience available on request</div>
  </div>
</div>
</section>

<section id="communities">
  <h2>communities</h2>

  <h3><a href="https://nycresistor.org">NYC Resistor</a></h3>
  <p>Member and teacher. Built out <a href="https://baculus.co">Baculus</a>, program and repair of CNC milling machines.</p>

  <h3><a href="http://recurse.com">Recurse Center</a></h3>
  <ul>
    <li>Participant. Created a custom NES/famicom controller (in C and arduino) that could playback emulator speedruns on real hardware, build the basics of a blockchain client in rust, and learned a bit about networking layers with an online MOOC.
    <li>Researched and built <a href="https://github.com/living-room">a programmable room</a>, including tools to introduce interactivity in a physical space.
    <li>Programmed C/C++/openFrameworks computer vision tools, and a node.js db/event queue to allow others to contribute new sensors and visualizers.
  </ul>

  <h3><a href="http://sfpc.io">School for Poetic Computation</a></h3>
  <p>Programmed and painted a <a href="http://www.dangermouse.net/esoteric/piet.html">piet</a> program whose source code is just a bitmap. Built a <a href="https://github.com/jedahan/pagesounds">network sonifier</a> to make it easier to understand what is going on with your machine and the rest of a local network. Made a collaborative light drawing robot out of an old pen plotter</p>
</section>

<section id="projects">
  <h2>projects</h2>

  <p>Won Hackaday's superconference <a href="https://hackaday.com/2016/11/16/solving-hackadays-crypto-challenge/#more-230676">Badge CTF</a>!</p>

  <p>Created a <a href="https://hackaday.io/project/7002-autones-zero-player-nesfamicom">0-Player Famicom</a> that played back speedruns on an unmodified famicom/NES using an arduino as a fake controller.

  <p>Built a game of <a href="http://events.ccc.de/camp/2011/wiki/BadgeAssassin">assassin</a> at <a href="http://events.ccc.de/camp/2011">CCC</a> using the <a href="http://r0ket.badge.events.ccc.de/">camp badges</a> radio as local radar, confused all nonparticipants.</p>

  <p>Creation of <a href="#">multiplayer synth</a> - a network/phone-controlled motors and relays using OSC and arduinos</p>

  <p>Captured <a href="http://islandlabs.org/space">photography of space</a> and the tri-state area and captured the curvature of the earth from 34,000m with off-the-shelf hardware</p>

  <p>Packaged around 100 applications for the <a href="http://exherbo.org/">exherbo linux</a> distribution, contributing to user documentation</p>

  <p>Built API to access live position tracking of thousands of attendees as part of the <a href="http://amd.hope.net">AMD at HOPE</a> team, during a three-day conference. Enabled developers to create games on the platform</p>
</section>

<section id="education">
  <h2>education</h2>

  <ul>
    <li>Bachelors of Computer Science / Digital Arts from Stony Brook University, Fall 2010
    <li>Attended Computer Science program at Carnegie Melon University, 2005-2007
  </ul>
</section>
