import { Box, Heading, Stack } from '@chakra-ui/react';

export const SimpleCard: React.FC<{
  title: React.ReactNode;
  action?: React.ReactNode;
}> = ({ title, action, children }) => (
  <Box border="1px solid" borderColor="gray.200" borderRadius={8}>
    <Stack
      direction="row"
      alignItems="center"
      justify="space-between"
      p={3}
      borderBottom="1px solid"
      borderColor="gray.200"
    >
      <Heading as="h3" size="sm">
        {title}
      </Heading>
      {action}
    </Stack>
    <Box p={3}>{children}</Box>
  </Box>
);
