import { SimpleGrid, Text } from '@chakra-ui/react';

export const SimpleLabelAndValueContainer: React.FC = ({ children }) => (
  <SimpleGrid as="dl" gridTemplateColumns="max-content auto" gridColumnGap={6}>
    {children}
  </SimpleGrid>
);

export const SimpleLabelAndValueItem: React.FC<{
  label: string;
  value: React.ReactNode;
}> = ({ label, value }) => (
  <>
    <Text as="dt" color="gray.500">
      {label}
    </Text>
    <Text as="dd">{value}</Text>
  </>
);
