import { Box, Stack } from '@chakra-ui/react';
import { Header } from '../components/Header';
import { Suspense } from 'react';
import { CenterSpinner } from '../components/CenterSpinner';
import { Outlet } from 'react-router-dom';

export const AppLayout: React.FC = () => {
  return (
    <Stack spacing={0} height="100%">
      <Header />
      <Box flex={1}>
        <Suspense fallback={<CenterSpinner />}>
          <Outlet />
        </Suspense>
      </Box>
    </Stack>
  );
};
