import { Box, Heading, Stack } from '@chakra-ui/react';

export const PageLayout: React.FC<{
  title: React.ReactNode;
  breadcrumbs: React.ReactNode;
  content: React.ReactNode;
  panel?: React.ReactNode;
}> = ({ title, breadcrumbs, content, panel }) => (
  <Stack direction="row" spacing={0} height="100%">
    <Stack flex={1} py={6}>
      {breadcrumbs}
      <Box p={6}>
        <Heading as="h2" size="md">
          {title}
        </Heading>
      </Box>
      {content}
    </Stack>
    {panel && (
      <Box
        maxWidth={400}
        flex={1}
        minHeight="100%"
        borderLeft="1px solid"
        borderColor="gray.200"
        px={4}
        py={6}
      >
        {panel}
      </Box>
    )}
  </Stack>
);
