import { Center, Heading, Stack, Text } from '@chakra-ui/react';

const Frown = () => (
  <svg width="128" height="128" fill="none" viewBox="0 0 24 24">
    <path
      stroke="currentColor"
      strokeLinecap="round"
      strokeLinejoin="round"
      strokeWidth="1.5"
      d="M8.75 4.75H15.25C17.4591 4.75 19.25 6.54086 19.25 8.75V15.25C19.25 17.4591 17.4591 19.25 15.25 19.25H8.75C6.54086 19.25 4.75 17.4591 4.75 15.25V8.75C4.75 6.54086 6.54086 4.75 8.75 4.75Z"
    />
    <path
      stroke="currentColor"
      strokeLinecap="round"
      strokeLinejoin="round"
      strokeWidth="1.5"
      d="M7.75 15.25C7.75 15.25 9 12.75 12 12.75C15 12.75 16.25 15.25 16.25 15.25"
    />
    <circle cx="14" cy="10" r="1" fill="currentColor" />
    <circle cx="10" cy="10" r="1" fill="currentColor" />
  </svg>
);

export const NotFoundPage: React.FC = () => (
  <Center height="100%" width="100%">
    <Frown />

    <Stack>
      <Heading>Not found</Heading>
      <Text>The requested page was not found.</Text>
    </Stack>
  </Center>
);
